import java.awt.*;
import java.awt.event.*;

class applibanque
 {
  public static void main(String args[])
  {
   Banque b=new Banque(20);
   Environnement e=new Environnement(b);
  }                                     
 }

class Banque
 {
  int    max_clients;
  int    nb_clients;
  compte clients[];

  Banque(int max_clients)
   {
    nb_clients=0;
    this.max_clients=max_clients;
    clients=new compte[max_clients];
   }

  void ajout_client(String nom,double solde,boolean compte_epargne)
   {
    if(nb_clients>=max_clients)
      {
       Avertissement a=
       new Avertissement("Plus de place dans le tableau clients");
       return;
      }
    if(compte_epargne)
       clients[nb_clients]=new compte_epargne(nom,solde);
    else
       clients[nb_clients]=new compte_cheque(nom,solde);
    nb_clients++;
   }
 }

class Environnement implements ActionListener
 {
  Banque b;

  Frame   fenetre_principale=new Frame("BANQUE");
  Button  b_creation        =new Button("Creer un compte"),
          b_consultation    =new Button("Consultation des clients");

  Env_creation ec;
  Env_liste    el;

  Gestionfenetre g=new Gestionfenetre();

  Environnement (Banque b)
   {
    this.b=b;

    ec=new Env_creation(b);

    fenetre_principale.setLayout(new FlowLayout());
    fenetre_principale.add(b_creation);
    fenetre_principale.add(b_consultation);

    fenetre_principale.pack();
    fenetre_principale.show();

    b_creation.addActionListener(this);
    b_consultation.addActionListener(this);
    fenetre_principale.addWindowListener(g);
   }

  public void actionPerformed(ActionEvent e)
   {
    Object o=e.getSource();

    if(o==b_creation)
      {

       if(ec.fenetre_creation.isShowing()==false) 
          ec.fenetre_creation.show();
       return; 
      }

    if(o==b_consultation)
      {
       el=new Env_liste(b);
       return;
      }

    System.out.println(e);
   }

 }

class Gestionfenetre extends WindowAdapter
 {

  public void windowClosing(WindowEvent e)
   {
    System.exit(0);
   }
 }

class Env_creation implements ActionListener,ItemListener
 {
  Banque b;

  Frame fenetre_creation=new Frame("Creation d'un compte");
  Button b_valider=new Button("Valider"),
         b_annuler=new Button("Annuler");
  CheckboxGroup groupe=new CheckboxGroup();
  Checkbox  cb1=new Checkbox("Compte epargne",groupe,true),
            cb2=new Checkbox("Compte cheque",groupe,false);
  Label     lnom=new Label("Nom du client"),
            lsolde=new Label("Solde initial");
  TextField tnom=new TextField("",30),
            tsolde=new TextField("",10);
  boolean   type_compte=true; // compte epargne par defaut

  Env_creation(Banque b)
   {
    this.b=b;
    fenetre_creation.setLayout(new FlowLayout());
    fenetre_creation.add(cb1);
    fenetre_creation.add(cb2);
    fenetre_creation.add(lnom);
    fenetre_creation.add(tnom);
    fenetre_creation.add(lsolde);
    fenetre_creation.add(tsolde);
    fenetre_creation.add(b_valider);
    fenetre_creation.add(b_annuler);

    fenetre_creation.pack();

    cb1.addItemListener(this);
    cb2.addItemListener(this);

    tnom.addActionListener(this);
    tsolde.addActionListener(this);
    b_valider.addActionListener(this);
    b_annuler.addActionListener(this);
    
   }

  public void actionPerformed(ActionEvent e)
   {
    Object o=e.getSource();
    String s;
    double m;

    if(o==b_annuler)
      {
       fenetre_creation.dispose();
       return;
      }

   if(o==b_valider)
     {
      s=tsolde.getText();
      try {
           m=new Double(s).doubleValue();
          }
      catch(NumberFormatException erreur)
          {
           Avertissement a=
           new Avertissement("Format de nombre incorrect");
           return;
          }
      b.ajout_client(tnom.getText(),m,type_compte);
      return;
     }

    System.out.println(e);
   }

  public void itemStateChanged(ItemEvent e)
   {
    Object o=e.getSource();

    if(o==cb1) type_compte=true;
    else       type_compte=false;
   }

 }

class Env_liste implements ActionListener,ItemListener
 {
  Banque b;

  Frame  fenetre_liste=new Frame("Consultations des comptes");
  Button b_quitter    =new Button("Quitter");
  Label    libelle    =new Label(
           "                                               ");
  List   liste        =new List(5);

  Env_liste(Banque b)
   {
    int i;

    this.b=b;
    for(i=0;i<b.nb_clients;i++) 
        liste.addItem(b.clients[i].nom_client);
    fenetre_liste.setLayout(new FlowLayout());
    fenetre_liste.add(liste);
    fenetre_liste.add(libelle);
    fenetre_liste.add(b_quitter);

    fenetre_liste.pack();
    fenetre_liste.show();
    liste.addItemListener(this);
    b_quitter.addActionListener(this);
    
   }

  public void actionPerformed(ActionEvent e)
   {
    Object o=e.getSource();

    if(o==b_quitter)
      {
       fenetre_liste.dispose();
       return;
      }

    System.out.println(e);
   }

  public void itemStateChanged(ItemEvent e)
   {
    Object o=e.getSource();
    int i;

    if(o==liste)
     {
      i=liste.getSelectedIndex();
      libelle.setText(b.clients[i].situation());
      return;
     }
    System.out.println(e);
   }

 }

class Avertissement implements ActionListener
 {
  Frame f=new Frame("Avertissement");
  Label libelle;

  Button ok=new Button("OK");

  Avertissement(String s)
   {

    libelle=new Label(s);
    f.setLayout(new FlowLayout());
    f.add(libelle);
    f.add(ok);
    f.pack();
    f.setLocation(200,300);
    f.show();
    ok.addActionListener(this);
   }

 public void actionPerformed(ActionEvent e)
  {
   Object o=e.getSource();

   if(o==ok)
     {
      f.dispose();
      return;
     }
   System.out.println(e);
  }
 }

abstract class compte
 {
  protected int numero_compte;
  protected String nom_client;
  protected double solde;

  compte(String nom,double montant)
   {
    nom_client=nom;
    solde=montant;
   }

  abstract double calcul_interets();

  String situation()
   {
    return numero_compte+" "+nom_client+
           " Solde "+solde+" Interets "+calcul_interets();
   }
 }

class compte_cheque extends compte
 {
  static int dernier_numero_utilise=100000;

  compte_cheque(String nom,double montant)
   {
    super(nom,montant);
    dernier_numero_utilise++;
    numero_compte=dernier_numero_utilise;
   }

  double calcul_interets()
   {
    return 0;
   }

 }

class compte_epargne extends compte
 {
  static int dernier_numero_utilise=800000;

  compte_epargne(String nom,double montant)
   {
    super(nom,montant);
    dernier_numero_utilise++;
    numero_compte=dernier_numero_utilise;
   }

  double calcul_interets()
   {
    return solde*4.5/100;
   }

 }

